:- module(benchmarks, [benchmark/5]).

benchmark(append,
	herbrand, 
	append(A, _, C), 
	[[A, C]],
	append(X, true, X)). 
benchmark(rotate,
	herbrand,
	rotate(_, B),
	[[B]],
	rotate(true, _)).
benchmark(qsort,
	herbrand,
	main(true, X),
	[[X]],
	main(true, _)).
benchmark(rev,
	herbrand,
	go,
	[],
	go).
benchmark(queens,
	herbrand,
	queens(A, B),
	[[A], [B]],
	queens(_, _)).
benchmark(zebra,
	herbrand,
	zebra(A, B, C, D, E, F, G),
	[[A], [B], [C], [D], [E], [F], [G]],
	zebra(_, _, _, _, _, _, _)).
benchmark(shape,
	herbrand,
	shapes(A, B),
	[[A], [B]],
	shapes(_, _)).
benchmark(treeorder,
	herbrand,
	v2t(A, B, C),
	[[A], [B], [C]],
	v2t(_, _, _)).
benchmark(music,
	herbrand,
	solve(A),
	[[A]],
	solve(_)).
benchmark(serialize,
	herbrand,
	serialize0(A, B),
	[[A], [B]],
	serialize0(_, _)).
benchmark(crypt_wamcc, 
	herbrand,
	crypt,
	[],
	crypt).
benchmark(dcg, 
	herbrand,
	go(A),
	[[A]],
	go(_)).
benchmark(hamiltonian,
	herbrand,
	main,
	[],
	main).
benchmark(poly10,
	herbrand,
	poly_10,
	[],
	poly_10).
benchmark(semi,
	herbrand,
	go(A, B),
	[[A], [B]],
	go(_, _)).
benchmark(life,
	herbrand,
	life(_, _, C, D),
	[[C], [D]],
	life(true, true, _, _)).
benchmark(ronp,
	herbrand,
	puzzle(A),
	[[A]],
	puzzle(_)).
benchmark(meta,
	herbrand,
	q,
	[],
	q).
benchmark(browse,
	herbrand, 
	q, 
	[],
	q).
benchmark(gabriel,
	herbrand,
	main(A, B),
	[[A], [B]],
	main(_, _)).
benchmark(tsp,
	herbrand,
	test,
	[],
	test).
benchmark(nandc,
	herbrand,
	play(A),
	[[A]],
	play(_)).
benchmark(disj_r,
	herbrand, 
	top(A),
	[[A]],
	top(_)).
benchmark(ga, 
	herbrand,
	test_ga,
	[],
	test_ga).
benchmark(scc1,
        herbrand,
        main,
        [],
        main).
benchmark('ime_v2-2-1',
	herbrand,
	linear_multi_equation(_, B),
	[[B]],
	linear_multi_equation(true, _)).
benchmark(cs_r, 
	herbrand,
	pgenconfig(A),
	[[A]],
	pgenconfig(_)).
benchmark(map,
	herbrand,
	main,
	[],
	main).
benchmark(neural,
	herbrand,
	go,
	[],
	go).
benchmark(kalah,
	herbrand,
	play(A, B),
	[[A], [B]],
	play(_, _)).
benchmark(unify,
	herbrand,
	u(A, B, C, D),
	[[A], [B], [C], [D]],
	u(_, _, _, _)).
benchmark(peep,
	herbrand,
	comppeepopt(A, B, C),
	[[A], [B], [C]],
	comppeepopt(_, _, _)).
benchmark(boyer, 
	herbrand,
	tautology(A), 
	[[A]],
	tautology(_)).
benchmark(bryant,
	herbrand, 
	goal, 
	[],
	goal).
benchmark(sdda,
	herbrand,
	main,
	[],
	main).
benchmark(read,
	herbrand,
	read(A, B),
	[[A], [B]],
	read(_, _)).
benchmark(press,
	herbrand,
	test_press(A, B),
	[[A], [B]],
	test_press(_, _)).
benchmark(qplan,
	herbrand,
	qplan(_, B),
	[[B]],
	qplan(true, _)).
benchmark(trs,
	herbrand,
	go,
	[],
	go).
benchmark(reducer,
	herbrand,
	main,
	[],
	main). 
benchmark(simple_analyzer,
	herbrand,
	main,
	[],
	main).
benchmark(ann, 
	herbrand,
	go(A), 
	[[A]],
	go(_)).
benchmark(asm, 
	herbrand,
	asm_PIL(_, _),
	[],
	asm_PIL(true, true)).
benchmark(chat_parser, 
	herbrand,
	chat_parser, 
	[],
	chat_parser).
benchmark('sim_v5-2',
	herbrand,
	go,
	[],
	go).
