:- module(fixpoint, [fixpoint/5]).
:- use_module([deter_fixpoint, pos_fixpoint]).

:- dynamic(user_atom/2).
:- dynamic(user_atom/3).

:- dynamic(head_to_clause/2).
:- dynamic(atom_to_clause/4).
:- dynamic(atom_to_dynamic/4).

fixpoint(td, con_nonground_model, _, _, Goal) :-	
	td_con_fixpoint(Goal), 
	prune_fixpoint_atoms.
fixpoint(td, det_nonground_model, _, _, Goal) :-	
	td_deter_fixpoint(Goal),
	prune_fixpoint_atoms.
fixpoint(td, msg_nonground_model, _, _, Goal) :-	
	td_msg_fixpoint(Goal),
	prune_fixpoint_atoms.
fixpoint(td, imp_nonground_model, _, _, Goal) :-	
	td_imp_fixpoint(Goal),
	prune_fixpoint_atoms.
fixpoint(td, def_nonground_model, _, _, Goal) :-	
	td_def_fixpoint(Goal),
	prune_fixpoint_atoms.
fixpoint(td, pos_nonground_model, _, _, Goal) :-	
	td_pos_fixpoint(Goal),
	prune_fixpoint_atoms.

prune_fixpoint_atoms :- 
	(user_atom(Goal, _); user_atom(Goal, _, _)),
	prune_fixpoint_atom(Goal),
	fail.
prune_fixpoint_atoms.

prune_fixpoint_atom(Goal) :-
	functor(Goal, Name, Arity),
	name(Name, [95, 95 | _]),
	!,
	functor(New_Goal, Name, Arity),
	retractall(user_atom(New_Goal, _)),
	retractall(user_atom(New_Goal, _, _)).
prune_fixpoint_atom(_).
